/**
 * WPPA potd block
 *
 * Version: 8.2.02.004
 */

jQuery(document).ready(function(){
( function ( blocks, editor, i18n, element, components, _, blockEditor ) {

	var el = element.createElement;
	var RichText = blockEditor.RichText;
	var useBlockProps = blockEditor.useBlockProps;

	blocks.registerBlockType( 'wp-photo-album-plus/potd', {
		title: wppaTextPotd,
		icon: el( 'img', {
							src: 	wppaImageDirectory+'camera32.png',
							style: 	{ width: '24px', height: '24px' },
						} ),
		category: 'layout',

		attributes: {
			widgetTitle: {
				type: 'string',
				selector: 'h2',
			},
			wppaShortcode: {
				type: 'string',
				value: '[wppa type="photo" photo="#potd"]',
			},
		},

		example: {
			attributes: {
				widgetTitle: 'Photo of the day',
				wppaShortcode: '[wppa type="photo" photo="#potd"]',
			},
		},


		edit: function( props ) {
			var blockProps = wp.blockEditor.useBlockProps();
			var attributes = props.attributes;

			return el(
				'div',
				blockProps,
				el('h2',null,wppaTextPhotoOfTheDay),
				wppaOnWidgets() ?
				el( RichText, {
					tagName: 'h3',
					placeholder: wppaTextEnterWidgetCaption,
					value: attributes.widgetTitle,
					onChange: function ( value ) {
						props.setAttributes( { 	widgetTitle: value,
												wppaShortcode: evaluate(),
												});
					},
				}) : null,
				el('small',null,wppaTextCorrShortcode+': '+evaluate(props)),
			);
		},

		save: function( props ) {
			var attributes = props.attributes;

			return el(
				'div',
				{},
				el('h3',{},attributes.widgetTitle),
				el('div',{},evaluate(props)),
			);
		},
	});

	function evaluate( props ) {
		var shortcode = '[wppa type="photo" photo="#potd"'+(wppaOnWidgets() ? ' widget="potd"' : '')+']';

		return shortcode;
	}

} )(
	window.wp.blocks,
	window.wp.editor,
	window.wp.i18n,
	window.wp.element,
	window.wp.components,
	window._,
	window.wp.blockEditor
)});
